<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="shortcut icon" type="image/x-icon" href="images/user.ico">
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.5/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.5/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.5/js/dataTables.bootstrap4.min.js"></script>
  <style>
    #role-table {
      font-family: "Roboto";
      font-weight: 200;
    }
    .custom-background-order-header {
      background: #5b9bd5;
      color: white;
    }
    #role-table tbody tr:nth-of-type(even) {
      background: #eaeff7;
    }
    #role-table tbody tr:nth-of-type(odd) {
      background: #d2deef;
    }
    .table thead th {
      border-bottom: 0.35rem solid #fff;
      border-right: 0.15rem solid #fff;
    }
    .table tbody td {
      border-bottom: 0.2rem solid #fff;
      border-right: 0.15rem solid #fff;
    }
  </style>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F100 - Quản trị Người Dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3 text-right mt-2 font-weight-bold">
          <label for="gRoleSelect">Role</label>
        </div>
        <div class="col-sm-3">
          <select id="gRoleSelect" class="form-control">
            
          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-success">Lọc dữ liệu</button>
        </div>
      </div>
  </div>
  
  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="role-table">
      <thead class="custom-background-order-header">
        <tr>
          <th>STT</th>
          <th>Username</th>
          <th>First name</th>
          <th>Last name</th>
          <th>Email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
<script>
  "use strict"
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gDICE_HISTORY_PAGE_NAME = "diceHistory.html";
  const gVOUCHER_HISTORY_PAGE_NAME = "voucherHistory.html";

  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager"
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];

  var gCOL_NAMES = ["stt", "username", "firstname", "lastname", "email", "age", "roleId", "action"];
  var gCOL_STT = 0;
  var gCOL_USER_NAME = 1;
  var gCOL_FIRST_NAME = 2;
  var gCOL_LAST_NAME= 3;
  var gCOL_EMAIL = 4;
  var gCOL_AGE = 5;
  var gCOL_ROLE = 6;
  var gCOL_ACTION = 7

  var gUserObj = {}
  var gUserId = 0;
  var gSTT = 0;

  var gUserDataTable = $("#role-table").DataTable({
    // Phân trang DataTable
    paging: true,
    // Bỏ thay đổi số dòng trên mỗi trang của bảng
    lengthChange: false,
    // Bỏ cho phép tìm kiếm trên bảng
    searching: false,
    // Không cho phép sắp xếp trên bảng
    ordering: false,
    columns: [
      { data: gCOL_NAMES[gCOL_STT] },
      { data: gCOL_NAMES[gCOL_USER_NAME] },
      { data: gCOL_NAMES[gCOL_FIRST_NAME] },
      { data: gCOL_NAMES[gCOL_LAST_NAME] },
      { data: gCOL_NAMES[gCOL_EMAIL] },
      { data: gCOL_NAMES[gCOL_AGE] },
      { data: gCOL_NAMES[gCOL_ROLE] },
      { data: gCOL_NAMES[gCOL_ACTION] },
    ],
    columnDefs: [
      {
        targets: gCOL_STT,
        render: function() {
          return ++ gSTT;
        }
      },
      {
        targets: gCOL_ACTION,
        defaultContent: `
          <i title="Xúc xắc" class="fa-solid fa-dice i-dice" style="color: purple; cursor: pointer"></i><span>&nbsp;&nbsp;</span>
          <i title="Quà" class="fa-solid fa-gift i-voucher" style="color: purple; cursor: pointer"></i> 
        `
      },
      {
        targets: gCOL_ROLE,
        render: function(paramRoleId) {
          return getRoleNameByRoleId(paramRoleId);
        }
      }
    ]
  });
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  // gọi hàm sự kiện xử lý khi load trang
  onPageLoading();  

  // hàm sự kiện cho nút "Lọc Dữ Liệu"
  $("#btn-filter-role").on("click", function() {
    onBtnFilterRoleClick();
  });

  // hàm sự kiện nhấn vào icon 'Dice'
  $("#role-table").on("click", ".i-dice", function() {
    onIconDiceClick(this);
  });

  // hàm sự kiện nhấn vào icon 'Voucher'
  $("#role-table").on("click", ".i-voucher", function() {
    onIconVoucherClick(this);
  });
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm sự kiện xử lý load trang  
  function onPageLoading() {
    // đổ dữ liệu vào DataTable
    loadRoleToDataTable(gUserObjects);

    // đổ dữ liệu vào thẻ Select Role
    loadDataToRoleSelect(gRoleObjects);
  }

  // hàm sự kiện lọc dữ liệu
  function onBtnFilterRoleClick() {
    // B0: Khai báo biến
    var vFilterParam = {
      roleId: 0
    }
    // B1: Thu thập dữ liệu
    getFilterRoleParam(vFilterParam);
    // B2: Kiểm tra dữ liệu (bỏ qua)
    // B3: Xử lý và hiển thị kết quả
    filterRoleData(vFilterParam);
  }

  // hàm sự kiện nhấn vào icon 'Dice' để chuyển sang trang History Dice
  function onIconDiceClick(paramClickedDiceIcon) {
    // lưu thông tin UserId đang được edit vào biến toàn cục
    gUserObj = getUserInforFromClickedIcon(paramClickedDiceIcon);
    // gọi và truyền data qua page dice.history.html
    var vUrlSiteToOpen = gDICE_HISTORY_PAGE_NAME + "?id=" + gUserObj.id + "&username=" + gUserObj.username + "&firstname="
      + gUserObj.firstname + "&lastname=" + gUserObj.lastname;
    window.location.href = vUrlSiteToOpen;
  }

  // hàm sự kiện nhấn vào icon 'Voucher' để chuyển sang trang History Voucher
  function onIconVoucherClick(paramClickedVoucherIcon) {
    // lưu thông tin UserId đang được edit vào biến toàn cục
    gUserObj = getUserInforFromClickedIcon(paramClickedVoucherIcon);
    // gọi và truyền data qua page dice.history.html
    var vUrlSiteToOpen = gVOUCHER_HISTORY_PAGE_NAME + "?id=" + gUserObj.id + "&username=" + gUserObj.username + "&firstname="
      + gUserObj.firstname + "&lastname=" + gUserObj.lastname;
    window.location.href = vUrlSiteToOpen;
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm load dữ liệu vào DataTable
  function loadRoleToDataTable(paramUserObjects) {
    gSTT = 0;
    gUserDataTable.clear();
    gUserDataTable.rows.add(paramUserObjects);
    gUserDataTable.draw();
  }

  // hàm trả về Role Name dựa vào Role Id
  function getRoleNameByRoleId(paramRoleId) {
    "use strict"
    var vRoleName = "";
    var vIndex = 0;
    var vIsRoleNameFound = false;
    while(!vIsRoleNameFound && vIndex < gRoleObjects.length) {
      if(gRoleObjects[vIndex].roleId === paramRoleId) {
        vIsRoleNameFound = true;
        vRoleName = gRoleObjects[vIndex].roleName;
      }
      else {
        vIndex ++;
      }
    }
    return vRoleName;
  }

  // hàm load dữ liệu Role vào Select box
  function loadDataToRoleSelect(paramRoleObjects) {
    var vRoleTypeSelect = $("#gRoleSelect");
    vRoleTypeSelect.append($("<option>", {
      value: 0,
      text: "--- Chọn Role ---"
    }));
    for(var bI = 0; bI < paramRoleObjects.length; bI ++) {
      vRoleTypeSelect.append($("<option>", {
        value: paramRoleObjects[bI].roleId,
        text: paramRoleObjects[bI].roleName
      }));
    }
  }

  // hàm thu thập dữ liệu lọc
  function getFilterRoleParam(paramFilter) {
    paramFilter.roleId = $("#gRoleSelect").val();
  }

  // hàm lọc và hiển thị dữ liệu Role
  function filterRoleData(paramFilter) {
    // lọc dữ liệu
    var vListByRoleName = [];
    vListByRoleName = gUserObjects.filter(function(user) {
      return(paramFilter.roleId == 0 || user.roleId == paramFilter.roleId)
    });
    
    // hiển thị dữ liệu
    loadRoleToDataTable(vListByRoleName);
    return vListByRoleName;
  }

  // hàm dựa vào icon đã click xác định được một số thông tin của User
  function getUserInforFromClickedIcon(paramClickedIcon) {
    var vUserInforObj = {
      id: 0,
      username: "",
      firstname: "",
      lastname: ""
    }
    var vTableRow = $(paramClickedIcon).parents("tr");
    var vUserRowData = gUserDataTable.row(vTableRow).data();
    // gán giá trị cho đối tượng UserInfor
    vUserInforObj.id = vUserRowData.id;
    vUserInforObj.username = vUserRowData.username;
    vUserInforObj.firstname = vUserRowData.firstname;
    vUserInforObj.lastname = vUserRowData.lastname;
    return vUserInforObj;
  }

</script>
</body>
</html>